/*************************************************************************
	Header file:  INCON.H

	INCON input handler prototypes state variables and.

	Compiler:  Borland Turbo C 2.01

	INCON source files and the object and library files created from
	them are:
		Copyright (c) 1993-94, Richard Zigler.
	You may freely distribute unmodified source, object, and library
	files, and incorporate them into your own non-commercial software,
	provided that this paragraph and the program name and copyright
	strings defined in INCON.C are included in all copies.
*************************************************************************/

#if !defined(INCON_STATE)
#define INCON_STATE

/**** Program States ****/

typedef enum
			{
			stError				= -1	,
			stQuit						,		/* [Enter] -- end input				*/
			stInit						,		/* field initialization				*/
			stFieldClear				,		/* [Esc] -- clear field or exit	*/
			stDeleteCharLeft			,		/* [Backspace] -- delete left		*/
			stMoveToStart				,		/* [Home] -- start of field		*/
			stMoveCharLeft				,		/* [Left Arrow] -- move char lt	*/
			stMoveCharRight			,		/* [Right Arrow] -- move char rt	*/
			stMoveToEnd					,		/* [End] -- end of field			*/
			stMoveWordLeft				,		/* [Ctrl Left] -- move word lt	*/
			stMoveWordRight			,		/* [Ctrl Right] -- move word rt	*/
			stDeleteWordLeft			,		/* [Ctrl L] -- delete word left	*/
			stDeleteWordRight			,		/* [Ctrl R] -- delete word right	*/
			stDeleteToEnd				,		/* [Ctrl End] -- clear to end		*/
			stDeleteToStart			,		/* [Ctrl Home] -- clear to start	*/
			stDeleteAtCursor			,		/* [Del] -- delete at cursor		*/
			stExitPlus					,		/* [Keypad +] -- special exit		*/
			stExitMinus					,		/* [Keypad -] -- special exit		*/
			stCharMatch					,		/* see if entry matches field		*/
			}
			STATES						;

/**** Input Handler Type ****/

typedef int				(pascal (* HANDLER)(STATES, int));

/**** Prototypes for Input-handling Routines. ****/

extern int	pascal	hAlphaField		( STATES, int	);		/* INALPHA.C	*/
extern int	pascal	hIntegerField	( STATES, int	);		/* ININTGR.C	*/
extern int	pascal	hFloatField		( STATES, int	);		/* INFLOAT.C	*/
extern int	pascal	hTemplateField	( STATES, int	);		/* INTEMPL.C	*/

#endif

/**** EOF:  INCON.H ****/
